#include "dpx.hpp"

/*
DPX::DPX(const std::string& filepath) {
    std::ifstream file(filepath, std::ios::binary);
    if (!file.is_open()) {
        throw std::runtime_error("Failed to open DPX file: " + filepath);
    }

    readHeader(file);
    readImageData(file, header.imageOffset);
}

void DPX::readHeader(std::ifstream& file) {
    DPXHeader header;
    file.read(reinterpret_cast<char*>(&header), sizeof(DPXHeader));
    
    // Check magic number (SDPX in ASCII)
    if (header.magic != 0x53445058) {
        if (header.magic == 0x58504453) { // XPDS - wrong endianness
            swapEndianness(reinterpret_cast<uint8_t*>(&header), sizeof(DPXHeader));
        } else {
            throw std::runtime_error("Invalid DPX file format");
        }
    }

    // Read image information header (located after main header)
    uint32_t orientation;
    file.read(reinterpret_cast<char*>(&orientation), sizeof(uint32_t));
    file.read(reinterpret_cast<char*>(&width), sizeof(uint32_t));
    file.read(reinterpret_cast<char*>(&height), sizeof(uint32_t));

    // Read image element information
    DPXImageElement element;
    file.read(reinterpret_cast<char*>(&element), sizeof(DPXImageElement));
    
    bitDepth = element.bitDepth;
}

void DPX::readImageData(std::ifstream& file, uint32_t imageOffset) {
    // Seek to image data
    file.seekg(imageOffset, std::ios::beg);

    // Calculate buffer size based on bit depth and dimensions
    size_t bytesPerPixel = (bitDepth + 7) / 8;
    size_t rowPadding = (width * 3 * bytesPerPixel) % 4 ? 4 - ((width * 3 * bytesPerPixel) % 4) : 0;
    size_t bufferSize = (width * 3 * bytesPerPixel + rowPadding) * height;

    // Read image data into buffer
    std::vector<uint8_t> buffer(bufferSize);
    file.read(reinterpret_cast<char*>(buffer.data()), bufferSize);

    processImageData(buffer);
}

void DPX::processImageData(std::vector<uint8_t>& buffer) {
    switch (bitDepth) {
        case 10:
            raw = cv::Mat(height, width, CV_16UC3);
            unpack10BitData(buffer, raw);
            break;
            
        case 16:
            raw = cv::Mat(height, width, CV_16UC3);
            // Handle 16-bit data
            for (int y = 0; y < height; y++) {
                for (int x = 0; x < width; x++) {
                    for (int c = 0; c < 3; c++) {
                        size_t idx = (y * width + x) * 6 + c * 2;
                        uint16_t value = (buffer[idx] << 8) | buffer[idx + 1];
                        raw.at<cv::Vec3w>(y, x)[c] = value;
                    }
                }
            }
            break;
            
        default:
            throw std::runtime_error("Unsupported bit depth: " + std::to_string(bitDepth));
    }
}

void DPX::unpack10BitData(const std::vector<uint8_t>& buffer, cv::Mat& output) {
    // Handle 10-bit packed data (DaVinci Resolve format)
    // 3 pixels (9 bytes) -> 3 * 10-bit values
    size_t pixelIdx = 0;
    for (size_t i = 0; i < buffer.size() - 8; i += 9) {
        int y = pixelIdx / width;
        int x = pixelIdx % width;
        
        if (y >= height) break;

        // Unpack 3 10-bit values from 9 bytes
        uint32_t val1 = ((buffer[i] << 2) | (buffer[i + 1] >> 6)) & 0x3FF;
        uint32_t val2 = ((buffer[i + 1] << 4) | (buffer[i + 2] >> 4)) & 0x3FF;
        uint32_t val3 = ((buffer[i + 2] << 6) | (buffer[i + 3] >> 2)) & 0x3FF;

        // Scale to 16-bit
        output.at<cv::Vec3w>(y, x)[0] = static_cast<uint16_t>(val1 << 6);
        output.at<cv::Vec3w>(y, x)[1] = static_cast<uint16_t>(val2 << 6);
        output.at<cv::Vec3w>(y, x)[2] = static_cast<uint16_t>(val3 << 6);
        
        pixelIdx++;
    }
}

cv::Mat DPX::convertTo8Bit() const {
    cv::Mat output;
    raw.convertTo(output, CV_8UC3, 1.0 / 256.0);
    return output;
}

cv::Mat DPX::convertTo10Bit() const {
    cv::Mat output;
    if (bitDepth == 16) {
        raw.convertTo(output, CV_16UC3, 1.0 / 64.0);
    } else {
        output = raw.clone();
    }
    return output;
}

void DPX::swapEndianness(uint8_t* data, size_t size) {
    for (size_t i = 0; i < size/2; i++) {
        std::swap(data[i], data[size - 1 - i]);
    }
}

bool DPX::isLittleEndian() const {
    uint16_t number = 0x1;
    uint8_t* ptr = reinterpret_cast<uint8_t*>(&number);
    return (*ptr == 1);
}
*/